/* Important note: Do not include any of the gl includes yourself!

 * include only this file, it will load gl.h etc properly so that

 * the compiler wont think it is calling a staticly bound dll 

 *

 * and make sure that you include windows.h before including this file

 */



#ifndef __PLASMA_OPENGL_H

#define __PLASMA_OPENGL_H



#ifdef __cplusplus

extern "C" {

#endif



#include <windows.h>



/* do this so that it wont declare everything as dllimport */

#undef WINGDIAPI

#define WINGDIAPI



#ifdef __GL_H__

  #error Do not manually include gl.h or glu.h

#endif

#ifdef __gl_h__

  #error Do not manually include gl.h or glu.h

#endif



#include <GL/gl.h>



#ifdef __GLU_H__

  #error Do not manually include gl.h or glu.h

#endif

#ifdef __glu_h__

  #error Do not manually include gl.h or glu.h

#endif



#include <GL/glu.h>



//////////////////////////////////////////////////////////////////////////

/* Extension functions Constants (ie EXT and ARB) */



// Best to obtain the fullish list from www.berkelium.com

// see http://www.berkelium.com/OpenGL/NVIDIA/extensions.html

#include "../glext.h"



//////////////////////////////////////////////////////////////////////////



#ifdef __PLASMA_OPENGL_C

  #define OPENGL_FN_DECL(r,f,p) r (APIENTRY *fn##f)p=NULL

#else

  #define OPENGL_FN_DECL(r,f,p) extern r (APIENTRY *fn##f)p

#endif



OPENGL_FN_DECL( void,             glAccum, (GLenum op, GLfloat value) );

OPENGL_FN_DECL( void,             glAlphaFunc, (GLenum func, GLclampf ref) );

OPENGL_FN_DECL( GLboolean,        glAreTexturesResident, (GLsizei n, const GLuint *textures, GLboolean *residences) );

OPENGL_FN_DECL( void,             glArrayElement, (GLint i) );

OPENGL_FN_DECL( void,             glBegin, (GLenum mode) );

OPENGL_FN_DECL( void,             glBindTexture, (GLenum target, GLuint texture) );

OPENGL_FN_DECL( void,             glBitmap, (GLsizei width, GLsizei height, GLfloat xorig, GLfloat yorig, GLfloat xmove, GLfloat ymove, const GLubyte *bitmap) );

OPENGL_FN_DECL( void,             glBlendFunc, (GLenum sfactor, GLenum dfactor) );

OPENGL_FN_DECL( void,             glCallList, (GLuint list) );

OPENGL_FN_DECL( void,             glCallLists, (GLsizei n, GLenum type, const GLvoid *lists) );

OPENGL_FN_DECL( void,             glClear, (GLbitfield mask) );

OPENGL_FN_DECL( void,             glClearAccum, (GLfloat red, GLfloat green, GLfloat blue, GLfloat alpha) );

OPENGL_FN_DECL( void,             glClearColor, (GLclampf red, GLclampf green, GLclampf blue, GLclampf alpha) );

OPENGL_FN_DECL( void,             glClearDepth, (GLclampd depth) );

OPENGL_FN_DECL( void,             glClearIndex, (GLfloat c) );

OPENGL_FN_DECL( void,             glClearStencil, (GLint s) );

OPENGL_FN_DECL( void,             glClipPlane, (GLenum plane, const GLdouble *equation) );

OPENGL_FN_DECL( void,             glColor3b, (GLbyte red, GLbyte green, GLbyte blue) );

OPENGL_FN_DECL( void,             glColor3bv, (const GLbyte *v) );

OPENGL_FN_DECL( void,             glColor3d, (GLdouble red, GLdouble green, GLdouble blue) );

OPENGL_FN_DECL( void,             glColor3dv, (const GLdouble *v) );

OPENGL_FN_DECL( void,             glColor3f, (GLfloat red, GLfloat green, GLfloat blue) );

OPENGL_FN_DECL( void,             glColor3fv, (const GLfloat *v) );

OPENGL_FN_DECL( void,             glColor3i, (GLint red, GLint green, GLint blue) );

OPENGL_FN_DECL( void,             glColor3iv, (const GLint *v) );

OPENGL_FN_DECL( void,             glColor3s, (GLshort red, GLshort green, GLshort blue) );

OPENGL_FN_DECL( void,             glColor3sv, (const GLshort *v) );

OPENGL_FN_DECL( void,             glColor3ub, (GLubyte red, GLubyte green, GLubyte blue) );

OPENGL_FN_DECL( void,             glColor3ubv, (const GLubyte *v) );

OPENGL_FN_DECL( void,             glColor3ui, (GLuint red, GLuint green, GLuint blue) );

OPENGL_FN_DECL( void,             glColor3uiv, (const GLuint *v) );

OPENGL_FN_DECL( void,             glColor3us, (GLushort red, GLushort green, GLushort blue) );

OPENGL_FN_DECL( void,             glColor3usv, (const GLushort *v) );

OPENGL_FN_DECL( void,             glColor4b, (GLbyte red, GLbyte green, GLbyte blue, GLbyte alpha) );

OPENGL_FN_DECL( void,             glColor4bv, (const GLbyte *v) );

OPENGL_FN_DECL( void,             glColor4d, (GLdouble red, GLdouble green, GLdouble blue, GLdouble alpha) );

OPENGL_FN_DECL( void,             glColor4dv, (const GLdouble *v) );

OPENGL_FN_DECL( void,             glColor4f, (GLfloat red, GLfloat green, GLfloat blue, GLfloat alpha) );

OPENGL_FN_DECL( void,             glColor4fv, (const GLfloat *v) );

OPENGL_FN_DECL( void,             glColor4i, (GLint red, GLint green, GLint blue, GLint alpha) );

OPENGL_FN_DECL( void,             glColor4iv, (const GLint *v) );

OPENGL_FN_DECL( void,             glColor4s, (GLshort red, GLshort green, GLshort blue, GLshort alpha) );

OPENGL_FN_DECL( void,             glColor4sv, (const GLshort *v) );

OPENGL_FN_DECL( void,             glColor4ub, (GLubyte red, GLubyte green, GLubyte blue, GLubyte alpha) );

OPENGL_FN_DECL( void,             glColor4ubv, (const GLubyte *v) );

OPENGL_FN_DECL( void,             glColor4ui, (GLuint red, GLuint green, GLuint blue, GLuint alpha) );

OPENGL_FN_DECL( void,             glColor4uiv, (const GLuint *v) );

OPENGL_FN_DECL( void,             glColor4us, (GLushort red, GLushort green, GLushort blue, GLushort alpha) );

OPENGL_FN_DECL( void,             glColor4usv, (const GLushort *v) );

OPENGL_FN_DECL( void,             glColorMask, (GLboolean red, GLboolean green, GLboolean blue, GLboolean alpha) );

OPENGL_FN_DECL( void,             glColorMaterial, (GLenum face, GLenum mode) );

OPENGL_FN_DECL( void,             glColorPointer, (GLint size, GLenum type, GLsizei stride, const GLvoid *pointer) );

OPENGL_FN_DECL( void,             glCopyPixels, (GLint x, GLint y, GLsizei width, GLsizei height, GLenum type) );

OPENGL_FN_DECL( void,             glCopyTexImage1D, (GLenum target, GLint level, GLenum internalformat, GLint x, GLint y, GLsizei width, GLint border) );

OPENGL_FN_DECL( void,             glCopyTexImage2D, (GLenum target, GLint level, GLenum internalformat, GLint x, GLint y, GLsizei width, GLsizei height, GLint border) );

OPENGL_FN_DECL( void,             glCopyTexSubImage1D, (GLenum target, GLint level, GLint xoffset, GLint x, GLint y, GLsizei width) );

OPENGL_FN_DECL( void,             glCopyTexSubImage2D, (GLenum target, GLint level, GLint xoffset, GLint yoffset, GLint x, GLint y, GLsizei width, GLsizei height) );

OPENGL_FN_DECL( void,             glCullFace, (GLenum mode) );

OPENGL_FN_DECL( void,             glDeleteLists, (GLuint list, GLsizei range) );

OPENGL_FN_DECL( void,             glDeleteTextures, (GLsizei n, const GLuint *textures) );

OPENGL_FN_DECL( void,             glDepthFunc, (GLenum func) );

OPENGL_FN_DECL( void,             glDepthMask, (GLboolean flag) );

OPENGL_FN_DECL( void,             glDepthRange, (GLclampd zNear, GLclampd zFar) );

OPENGL_FN_DECL( void,             glDisable, (GLenum cap) );

OPENGL_FN_DECL( void,             glDisableClientState, (GLenum array) );

OPENGL_FN_DECL( void,             glDrawArrays, (GLenum mode, GLint first, GLsizei count) );

OPENGL_FN_DECL( void,             glDrawBuffer, (GLenum mode) );

OPENGL_FN_DECL( void,             glDrawElements, (GLenum mode, GLsizei count, GLenum type, const GLvoid *indices) );

OPENGL_FN_DECL( void,             glDrawPixels, (GLsizei width, GLsizei height, GLenum format, GLenum type, const GLvoid *pixels) );

OPENGL_FN_DECL( void,             glEdgeFlag, (GLboolean flag) );

OPENGL_FN_DECL( void,             glEdgeFlagPointer, (GLsizei stride, const GLboolean *pointer) );

OPENGL_FN_DECL( void,             glEdgeFlagv, (const GLboolean *flag) );

OPENGL_FN_DECL( void,             glEnable, (GLenum cap) );

OPENGL_FN_DECL( void,             glEnableClientState, (GLenum array) );

OPENGL_FN_DECL( void,             glEnd, (void) );

OPENGL_FN_DECL( void,             glEndList, (void) );

OPENGL_FN_DECL( void,             glEvalCoord1d, (GLdouble u) );

OPENGL_FN_DECL( void,             glEvalCoord1dv, (const GLdouble *u) );

OPENGL_FN_DECL( void,             glEvalCoord1f, (GLfloat u) );

OPENGL_FN_DECL( void,             glEvalCoord1fv, (const GLfloat *u) );

OPENGL_FN_DECL( void,             glEvalCoord2d, (GLdouble u, GLdouble v) );

OPENGL_FN_DECL( void,             glEvalCoord2dv, (const GLdouble *u) );

OPENGL_FN_DECL( void,             glEvalCoord2f, (GLfloat u, GLfloat v) );

OPENGL_FN_DECL( void,             glEvalCoord2fv, (const GLfloat *u) );

OPENGL_FN_DECL( void,             glEvalMesh1, (GLenum mode, GLint i1, GLint i2) );

OPENGL_FN_DECL( void,             glEvalMesh2, (GLenum mode, GLint i1, GLint i2, GLint j1, GLint j2) );

OPENGL_FN_DECL( void,             glEvalPoint1, (GLint i) );

OPENGL_FN_DECL( void,             glEvalPoint2, (GLint i, GLint j) );

OPENGL_FN_DECL( void,             glFeedbackBuffer, (GLsizei size, GLenum type, GLfloat *buffer) );

OPENGL_FN_DECL( void,             glFinish, (void) );

OPENGL_FN_DECL( void,             glFlush, (void) );

OPENGL_FN_DECL( void,             glFogf, (GLenum pname, GLfloat param) );

OPENGL_FN_DECL( void,             glFogfv, (GLenum pname, const GLfloat *params) );

OPENGL_FN_DECL( void,             glFogi, (GLenum pname, GLint param) );

OPENGL_FN_DECL( void,             glFogiv, (GLenum pname, const GLint *params) );

OPENGL_FN_DECL( void,             glFrontFace, (GLenum mode) );

OPENGL_FN_DECL( void,             glFrustum, (GLdouble left, GLdouble right, GLdouble bottom, GLdouble top, GLdouble zNear, GLdouble zFar) );

OPENGL_FN_DECL( GLuint,           glGenLists, (GLsizei range) );

OPENGL_FN_DECL( void,             glGenTextures, (GLsizei n, GLuint *textures) );

OPENGL_FN_DECL( void,             glGetBooleanv, (GLenum pname, GLboolean *params) );

OPENGL_FN_DECL( void,             glGetClipPlane, (GLenum plane, GLdouble *equation) );

OPENGL_FN_DECL( void,             glGetDoublev, (GLenum pname, GLdouble *params) );

OPENGL_FN_DECL( GLenum,           glGetError, (void) );

OPENGL_FN_DECL( void,             glGetFloatv, (GLenum pname, GLfloat *params) );

OPENGL_FN_DECL( void,             glGetIntegerv, (GLenum pname, GLint *params) );

OPENGL_FN_DECL( void,             glGetLightfv, (GLenum light, GLenum pname, GLfloat *params) );

OPENGL_FN_DECL( void,             glGetLightiv, (GLenum light, GLenum pname, GLint *params) );

OPENGL_FN_DECL( void,             glGetMapdv, (GLenum target, GLenum query, GLdouble *v) );

OPENGL_FN_DECL( void,             glGetMapfv, (GLenum target, GLenum query, GLfloat *v) );

OPENGL_FN_DECL( void,             glGetMapiv, (GLenum target, GLenum query, GLint *v) );

OPENGL_FN_DECL( void,             glGetMaterialfv, (GLenum face, GLenum pname, GLfloat *params) );

OPENGL_FN_DECL( void,             glGetMaterialiv, (GLenum face, GLenum pname, GLint *params) );

OPENGL_FN_DECL( void,             glGetPixelMapfv, (GLenum map, GLfloat *values) );

OPENGL_FN_DECL( void,             glGetPixelMapuiv, (GLenum map, GLuint *values) );

OPENGL_FN_DECL( void,             glGetPixelMapusv, (GLenum map, GLushort *values) );

OPENGL_FN_DECL( void,             glGetPointerv, (GLenum pname, GLvoid* *params) );

OPENGL_FN_DECL( void,             glGetPolygonStipple, (GLubyte *mask) );

OPENGL_FN_DECL( const GLubyte*,   glGetString, (GLenum name) );

OPENGL_FN_DECL( void,             glGetTexEnvfv, (GLenum target, GLenum pname, GLfloat *params) );

OPENGL_FN_DECL( void,             glGetTexEnviv, (GLenum target, GLenum pname, GLint *params) );

OPENGL_FN_DECL( void,             glGetTexGendv, (GLenum coord, GLenum pname, GLdouble *params) );

OPENGL_FN_DECL( void,             glGetTexGenfv, (GLenum coord, GLenum pname, GLfloat *params) );

OPENGL_FN_DECL( void,             glGetTexGeniv, (GLenum coord, GLenum pname, GLint *params) );

OPENGL_FN_DECL( void,             glGetTexImage, (GLenum target, GLint level, GLenum format, GLenum type, GLvoid *pixels) );

OPENGL_FN_DECL( void,             glGetTexLevelParameterfv, (GLenum target, GLint level, GLenum pname, GLfloat *params) );

OPENGL_FN_DECL( void,             glGetTexLevelParameteriv, (GLenum target, GLint level, GLenum pname, GLint *params) );

OPENGL_FN_DECL( void,             glGetTexParameterfv, (GLenum target, GLenum pname, GLfloat *params) );

OPENGL_FN_DECL( void,             glGetTexParameteriv, (GLenum target, GLenum pname, GLint *params) );

OPENGL_FN_DECL( void,             glHint, (GLenum target, GLenum mode) );

OPENGL_FN_DECL( void,             glIndexMask, (GLuint mask) );

OPENGL_FN_DECL( void,             glIndexPointer, (GLenum type, GLsizei stride, const GLvoid *pointer) );

OPENGL_FN_DECL( void,             glIndexd, (GLdouble c) );

OPENGL_FN_DECL( void,             glIndexdv, (const GLdouble *c) );

OPENGL_FN_DECL( void,             glIndexf, (GLfloat c) );

OPENGL_FN_DECL( void,             glIndexfv, (const GLfloat *c) );

OPENGL_FN_DECL( void,             glIndexi, (GLint c) );

OPENGL_FN_DECL( void,             glIndexiv, (const GLint *c) );

OPENGL_FN_DECL( void,             glIndexs, (GLshort c) );

OPENGL_FN_DECL( void,             glIndexsv, (const GLshort *c) );

OPENGL_FN_DECL( void,             glIndexub, (GLubyte c) );

OPENGL_FN_DECL( void,             glIndexubv, (const GLubyte *c) );

OPENGL_FN_DECL( void,             glInitNames, (void) );

OPENGL_FN_DECL( void,             glInterleavedArrays, (GLenum format, GLsizei stride, const GLvoid *pointer) );

OPENGL_FN_DECL( GLboolean,        glIsEnabled, (GLenum cap) );

OPENGL_FN_DECL( GLboolean,        glIsList, (GLuint list) );

OPENGL_FN_DECL( GLboolean,        glIsTexture, (GLuint texture) );

OPENGL_FN_DECL( void,             glLightModelf, (GLenum pname, GLfloat param) );

OPENGL_FN_DECL( void,             glLightModelfv, (GLenum pname, const GLfloat *params) );

OPENGL_FN_DECL( void,             glLightModeli, (GLenum pname, GLint param) );

OPENGL_FN_DECL( void,             glLightModeliv, (GLenum pname, const GLint *params) );

OPENGL_FN_DECL( void,             glLightf, (GLenum light, GLenum pname, GLfloat param) );

OPENGL_FN_DECL( void,             glLightfv, (GLenum light, GLenum pname, const GLfloat *params) );

OPENGL_FN_DECL( void,             glLighti, (GLenum light, GLenum pname, GLint param) );

OPENGL_FN_DECL( void,             glLightiv, (GLenum light, GLenum pname, const GLint *params) );

OPENGL_FN_DECL( void,             glLineStipple, (GLint factor, GLushort pattern) );

OPENGL_FN_DECL( void,             glLineWidth, (GLfloat width) );

OPENGL_FN_DECL( void,             glListBase, (GLuint base) );

OPENGL_FN_DECL( void,             glLoadIdentity, (void) );

OPENGL_FN_DECL( void,             glLoadMatrixd, (const GLdouble *m) );

OPENGL_FN_DECL( void,             glLoadMatrixf, (const GLfloat *m) );

OPENGL_FN_DECL( void,             glLoadName, (GLuint name) );

OPENGL_FN_DECL( void,             glLogicOp, (GLenum opcode) );

OPENGL_FN_DECL( void,             glMap1d, (GLenum target, GLdouble u1, GLdouble u2, GLint stride, GLint order, const GLdouble *points) );

OPENGL_FN_DECL( void,             glMap1f, (GLenum target, GLfloat u1, GLfloat u2, GLint stride, GLint order, const GLfloat *points) );

OPENGL_FN_DECL( void,             glMap2d, (GLenum target, GLdouble u1, GLdouble u2, GLint ustride, GLint uorder, GLdouble v1, GLdouble v2, GLint vstride, GLint vorder, const GLdouble *points) );

OPENGL_FN_DECL( void,             glMap2f, (GLenum target, GLfloat u1, GLfloat u2, GLint ustride, GLint uorder, GLfloat v1, GLfloat v2, GLint vstride, GLint vorder, const GLfloat *points) );

OPENGL_FN_DECL( void,             glMapGrid1d, (GLint un, GLdouble u1, GLdouble u2) );

OPENGL_FN_DECL( void,             glMapGrid1f, (GLint un, GLfloat u1, GLfloat u2) );

OPENGL_FN_DECL( void,             glMapGrid2d, (GLint un, GLdouble u1, GLdouble u2, GLint vn, GLdouble v1, GLdouble v2) );

OPENGL_FN_DECL( void,             glMapGrid2f, (GLint un, GLfloat u1, GLfloat u2, GLint vn, GLfloat v1, GLfloat v2) );

OPENGL_FN_DECL( void,             glMaterialf, (GLenum face, GLenum pname, GLfloat param) );

OPENGL_FN_DECL( void,             glMaterialfv, (GLenum face, GLenum pname, const GLfloat *params) );

OPENGL_FN_DECL( void,             glMateriali, (GLenum face, GLenum pname, GLint param) );

OPENGL_FN_DECL( void,             glMaterialiv, (GLenum face, GLenum pname, const GLint *params) );

OPENGL_FN_DECL( void,             glMatrixMode, (GLenum mode) );

OPENGL_FN_DECL( void,             glMultMatrixd, (const GLdouble *m) );

OPENGL_FN_DECL( void,             glMultMatrixf, (const GLfloat *m) );

OPENGL_FN_DECL( void,             glNewList, (GLuint list, GLenum mode) );

OPENGL_FN_DECL( void,             glNormal3b, (GLbyte nx, GLbyte ny, GLbyte nz) );

OPENGL_FN_DECL( void,             glNormal3bv, (const GLbyte *v) );

OPENGL_FN_DECL( void,             glNormal3d, (GLdouble nx, GLdouble ny, GLdouble nz) );

OPENGL_FN_DECL( void,             glNormal3dv, (const GLdouble *v) );

OPENGL_FN_DECL( void,             glNormal3f, (GLfloat nx, GLfloat ny, GLfloat nz) );

OPENGL_FN_DECL( void,             glNormal3fv, (const GLfloat *v) );

OPENGL_FN_DECL( void,             glNormal3i, (GLint nx, GLint ny, GLint nz) );

OPENGL_FN_DECL( void,             glNormal3iv, (const GLint *v) );

OPENGL_FN_DECL( void,             glNormal3s, (GLshort nx, GLshort ny, GLshort nz) );

OPENGL_FN_DECL( void,             glNormal3sv, (const GLshort *v) );

OPENGL_FN_DECL( void,             glNormalPointer, (GLenum type, GLsizei stride, const GLvoid *pointer) );

OPENGL_FN_DECL( void,             glOrtho, (GLdouble left, GLdouble right, GLdouble bottom, GLdouble top, GLdouble zNear, GLdouble zFar) );

OPENGL_FN_DECL( void,             glPassThrough, (GLfloat token) );

OPENGL_FN_DECL( void,             glPixelMapfv, (GLenum map, GLint mapsize, const GLfloat *values) );

OPENGL_FN_DECL( void,             glPixelMapuiv, (GLenum map, GLint mapsize, const GLuint *values) );

OPENGL_FN_DECL( void,             glPixelMapusv, (GLenum map, GLint mapsize, const GLushort *values) );

OPENGL_FN_DECL( void,             glPixelStoref, (GLenum pname, GLfloat param) );

OPENGL_FN_DECL( void,             glPixelStorei, (GLenum pname, GLint param) );

OPENGL_FN_DECL( void,             glPixelTransferf, (GLenum pname, GLfloat param) );

OPENGL_FN_DECL( void,             glPixelTransferi, (GLenum pname, GLint param) );

OPENGL_FN_DECL( void,             glPixelZoom, (GLfloat xfactor, GLfloat yfactor) );

OPENGL_FN_DECL( void,             glPointSize, (GLfloat size) );

OPENGL_FN_DECL( void,             glPolygonMode, (GLenum face, GLenum mode) );

OPENGL_FN_DECL( void,             glPolygonOffset, (GLfloat factor, GLfloat units) );

OPENGL_FN_DECL( void,             glPolygonStipple, (const GLubyte *mask) );

OPENGL_FN_DECL( void,             glPopAttrib, (void) );

OPENGL_FN_DECL( void,             glPopClientAttrib, (void) );

OPENGL_FN_DECL( void,             glPopMatrix, (void) );

OPENGL_FN_DECL( void,             glPopName, (void) );

OPENGL_FN_DECL( void,             glPrioritizeTextures, (GLsizei n, const GLuint *textures, const GLclampf *priorities) );

OPENGL_FN_DECL( void,             glPushAttrib, (GLbitfield mask) );

OPENGL_FN_DECL( void,             glPushClientAttrib, (GLbitfield mask) );

OPENGL_FN_DECL( void,             glPushMatrix, (void) );

OPENGL_FN_DECL( void,             glPushName, (GLuint name) );

OPENGL_FN_DECL( void,             glRasterPos2d, (GLdouble x, GLdouble y) );

OPENGL_FN_DECL( void,             glRasterPos2dv, (const GLdouble *v) );

OPENGL_FN_DECL( void,             glRasterPos2f, (GLfloat x, GLfloat y) );

OPENGL_FN_DECL( void,             glRasterPos2fv, (const GLfloat *v) );

OPENGL_FN_DECL( void,             glRasterPos2i, (GLint x, GLint y) );

OPENGL_FN_DECL( void,             glRasterPos2iv, (const GLint *v) );

OPENGL_FN_DECL( void,             glRasterPos2s, (GLshort x, GLshort y) );

OPENGL_FN_DECL( void,             glRasterPos2sv, (const GLshort *v) );

OPENGL_FN_DECL( void,             glRasterPos3d, (GLdouble x, GLdouble y, GLdouble z) );

OPENGL_FN_DECL( void,             glRasterPos3dv, (const GLdouble *v) );

OPENGL_FN_DECL( void,             glRasterPos3f, (GLfloat x, GLfloat y, GLfloat z) );

OPENGL_FN_DECL( void,             glRasterPos3fv, (const GLfloat *v) );

OPENGL_FN_DECL( void,             glRasterPos3i, (GLint x, GLint y, GLint z) );

OPENGL_FN_DECL( void,             glRasterPos3iv, (const GLint *v) );

OPENGL_FN_DECL( void,             glRasterPos3s, (GLshort x, GLshort y, GLshort z) );

OPENGL_FN_DECL( void,             glRasterPos3sv, (const GLshort *v) );

OPENGL_FN_DECL( void,             glRasterPos4d, (GLdouble x, GLdouble y, GLdouble z, GLdouble w) );

OPENGL_FN_DECL( void,             glRasterPos4dv, (const GLdouble *v) );

OPENGL_FN_DECL( void,             glRasterPos4f, (GLfloat x, GLfloat y, GLfloat z, GLfloat w) );

OPENGL_FN_DECL( void,             glRasterPos4fv, (const GLfloat *v) );

OPENGL_FN_DECL( void,             glRasterPos4i, (GLint x, GLint y, GLint z, GLint w) );

OPENGL_FN_DECL( void,             glRasterPos4iv, (const GLint *v) );

OPENGL_FN_DECL( void,             glRasterPos4s, (GLshort x, GLshort y, GLshort z, GLshort w) );

OPENGL_FN_DECL( void,             glRasterPos4sv, (const GLshort *v) );

OPENGL_FN_DECL( void,             glReadBuffer, (GLenum mode) );

OPENGL_FN_DECL( void,             glReadPixels, (GLint x, GLint y, GLsizei width, GLsizei height, GLenum format, GLenum type, GLvoid *pixels) );

OPENGL_FN_DECL( void,             glRectd, (GLdouble x1, GLdouble y1, GLdouble x2, GLdouble y2) );

OPENGL_FN_DECL( void,             glRectdv, (const GLdouble *v1, const GLdouble *v2) );

OPENGL_FN_DECL( void,             glRectf, (GLfloat x1, GLfloat y1, GLfloat x2, GLfloat y2) );

OPENGL_FN_DECL( void,             glRectfv, (const GLfloat *v1, const GLfloat *v2) );

OPENGL_FN_DECL( void,             glRecti, (GLint x1, GLint y1, GLint x2, GLint y2) );

OPENGL_FN_DECL( void,             glRectiv, (const GLint *v1, const GLint *v2) );

OPENGL_FN_DECL( void,             glRects, (GLshort x1, GLshort y1, GLshort x2, GLshort y2) );

OPENGL_FN_DECL( void,             glRectsv, (const GLshort *v1, const GLshort *v2) );

OPENGL_FN_DECL( GLint,            glRenderMode, (GLenum mode) );

OPENGL_FN_DECL( void,             glRotated, (GLdouble angle, GLdouble x, GLdouble y, GLdouble z) );

OPENGL_FN_DECL( void,             glRotatef, (GLfloat angle, GLfloat x, GLfloat y, GLfloat z) );

OPENGL_FN_DECL( void,             glScaled, (GLdouble x, GLdouble y, GLdouble z) );

OPENGL_FN_DECL( void,             glScalef, (GLfloat x, GLfloat y, GLfloat z) );

OPENGL_FN_DECL( void,             glScissor, (GLint x, GLint y, GLsizei width, GLsizei height) );

OPENGL_FN_DECL( void,             glSelectBuffer, (GLsizei size, GLuint *buffer) );

OPENGL_FN_DECL( void,             glShadeModel, (GLenum mode) );

OPENGL_FN_DECL( void,             glStencilFunc, (GLenum func, GLint ref, GLuint mask) );

OPENGL_FN_DECL( void,             glStencilMask, (GLuint mask) );

OPENGL_FN_DECL( void,             glStencilOp, (GLenum fail, GLenum zfail, GLenum zpass) );

OPENGL_FN_DECL( void,             glTexCoord1d, (GLdouble s) );

OPENGL_FN_DECL( void,             glTexCoord1dv, (const GLdouble *v) );

OPENGL_FN_DECL( void,             glTexCoord1f, (GLfloat s) );

OPENGL_FN_DECL( void,             glTexCoord1fv, (const GLfloat *v) );

OPENGL_FN_DECL( void,             glTexCoord1i, (GLint s) );

OPENGL_FN_DECL( void,             glTexCoord1iv, (const GLint *v) );

OPENGL_FN_DECL( void,             glTexCoord1s, (GLshort s) );

OPENGL_FN_DECL( void,             glTexCoord1sv, (const GLshort *v) );

OPENGL_FN_DECL( void,             glTexCoord2d, (GLdouble s, GLdouble t) );

OPENGL_FN_DECL( void,             glTexCoord2dv, (const GLdouble *v) );

OPENGL_FN_DECL( void,             glTexCoord2f, (GLfloat s, GLfloat t) );

OPENGL_FN_DECL( void,             glTexCoord2fv, (const GLfloat *v) );

OPENGL_FN_DECL( void,             glTexCoord2i, (GLint s, GLint t) );

OPENGL_FN_DECL( void,             glTexCoord2iv, (const GLint *v) );

OPENGL_FN_DECL( void,             glTexCoord2s, (GLshort s, GLshort t) );

OPENGL_FN_DECL( void,             glTexCoord2sv, (const GLshort *v) );

OPENGL_FN_DECL( void,             glTexCoord3d, (GLdouble s, GLdouble t, GLdouble r) );

OPENGL_FN_DECL( void,             glTexCoord3dv, (const GLdouble *v) );

OPENGL_FN_DECL( void,             glTexCoord3f, (GLfloat s, GLfloat t, GLfloat r) );

OPENGL_FN_DECL( void,             glTexCoord3fv, (const GLfloat *v) );

OPENGL_FN_DECL( void,             glTexCoord3i, (GLint s, GLint t, GLint r) );

OPENGL_FN_DECL( void,             glTexCoord3iv, (const GLint *v) );

OPENGL_FN_DECL( void,             glTexCoord3s, (GLshort s, GLshort t, GLshort r) );

OPENGL_FN_DECL( void,             glTexCoord3sv, (const GLshort *v) );

OPENGL_FN_DECL( void,             glTexCoord4d, (GLdouble s, GLdouble t, GLdouble r, GLdouble q) );

OPENGL_FN_DECL( void,             glTexCoord4dv, (const GLdouble *v) );

OPENGL_FN_DECL( void,             glTexCoord4f, (GLfloat s, GLfloat t, GLfloat r, GLfloat q) );

OPENGL_FN_DECL( void,             glTexCoord4fv, (const GLfloat *v) );

OPENGL_FN_DECL( void,             glTexCoord4i, (GLint s, GLint t, GLint r, GLint q) );

OPENGL_FN_DECL( void,             glTexCoord4iv, (const GLint *v) );

OPENGL_FN_DECL( void,             glTexCoord4s, (GLshort s, GLshort t, GLshort r, GLshort q) );

OPENGL_FN_DECL( void,             glTexCoord4sv, (const GLshort *v) );

OPENGL_FN_DECL( void,             glTexCoordPointer, (GLint size, GLenum type, GLsizei stride, const GLvoid *pointer) );

OPENGL_FN_DECL( void,             glTexEnvf, (GLenum target, GLenum pname, GLfloat param) );

OPENGL_FN_DECL( void,             glTexEnvfv, (GLenum target, GLenum pname, const GLfloat *params) );

OPENGL_FN_DECL( void,             glTexEnvi, (GLenum target, GLenum pname, GLint param) );

OPENGL_FN_DECL( void,             glTexEnviv, (GLenum target, GLenum pname, const GLint *params) );

OPENGL_FN_DECL( void,             glTexGend, (GLenum coord, GLenum pname, GLdouble param) );

OPENGL_FN_DECL( void,             glTexGendv, (GLenum coord, GLenum pname, const GLdouble *params) );

OPENGL_FN_DECL( void,             glTexGenf, (GLenum coord, GLenum pname, GLfloat param) );

OPENGL_FN_DECL( void,             glTexGenfv, (GLenum coord, GLenum pname, const GLfloat *params) );

OPENGL_FN_DECL( void,             glTexGeni, (GLenum coord, GLenum pname, GLint param) );

OPENGL_FN_DECL( void,             glTexGeniv, (GLenum coord, GLenum pname, const GLint *params) );

OPENGL_FN_DECL( void,             glTexImage1D, (GLenum target, GLint level, GLint components, GLsizei width, GLint border, GLenum format, GLenum type, const GLvoid *pixels) );

OPENGL_FN_DECL( void,             glTexImage2D, (GLenum target, GLint level, GLint internalformat, GLsizei width, GLsizei height, GLint border, GLenum format, GLenum type, const GLvoid *pixels) );

OPENGL_FN_DECL( void,             glTexParameterf, (GLenum target, GLenum pname, GLfloat param) );

OPENGL_FN_DECL( void,             glTexParameterfv, (GLenum target, GLenum pname, const GLfloat *params) );

OPENGL_FN_DECL( void,             glTexParameteri, (GLenum target, GLenum pname, GLint param) );

OPENGL_FN_DECL( void,             glTexParameteriv, (GLenum target, GLenum pname, const GLint *params) );

OPENGL_FN_DECL( void,             glTexSubImage1D, (GLenum target, GLint level, GLint xoffset, GLsizei width, GLenum format, GLenum type, const GLvoid *pixels) );

OPENGL_FN_DECL( void,             glTexSubImage2D, (GLenum target, GLint level, GLint xoffset, GLint yoffset, GLsizei width, GLsizei height, GLenum format, GLenum type, const GLvoid *pixels) );

OPENGL_FN_DECL( void,             glTranslated, (GLdouble x, GLdouble y, GLdouble z) );

OPENGL_FN_DECL( void,             glTranslatef, (GLfloat x, GLfloat y, GLfloat z) );

OPENGL_FN_DECL( void,             glVertex2d, (GLdouble x, GLdouble y) );

OPENGL_FN_DECL( void,             glVertex2dv, (const GLdouble *v) );

OPENGL_FN_DECL( void,             glVertex2f, (GLfloat x, GLfloat y) );

OPENGL_FN_DECL( void,             glVertex2fv, (const GLfloat *v) );

OPENGL_FN_DECL( void,             glVertex2i, (GLint x, GLint y) );

OPENGL_FN_DECL( void,             glVertex2iv, (const GLint *v) );

OPENGL_FN_DECL( void,             glVertex2s, (GLshort x, GLshort y) );

OPENGL_FN_DECL( void,             glVertex2sv, (const GLshort *v) );

OPENGL_FN_DECL( void,             glVertex3d, (GLdouble x, GLdouble y, GLdouble z) );

OPENGL_FN_DECL( void,             glVertex3dv, (const GLdouble *v) );

OPENGL_FN_DECL( void,             glVertex3f, (GLfloat x, GLfloat y, GLfloat z) );

OPENGL_FN_DECL( void,             glVertex3fv, (const GLfloat *v) );

OPENGL_FN_DECL( void,             glVertex3i, (GLint x, GLint y, GLint z) );

OPENGL_FN_DECL( void,             glVertex3iv, (const GLint *v) );

OPENGL_FN_DECL( void,             glVertex3s, (GLshort x, GLshort y, GLshort z) );

OPENGL_FN_DECL( void,             glVertex3sv, (const GLshort *v) );

OPENGL_FN_DECL( void,             glVertex4d, (GLdouble x, GLdouble y, GLdouble z, GLdouble w) );

OPENGL_FN_DECL( void,             glVertex4dv, (const GLdouble *v) );

OPENGL_FN_DECL( void,             glVertex4f, (GLfloat x, GLfloat y, GLfloat z, GLfloat w) );

OPENGL_FN_DECL( void,             glVertex4fv, (const GLfloat *v) );

OPENGL_FN_DECL( void,             glVertex4i, (GLint x, GLint y, GLint z, GLint w) );

OPENGL_FN_DECL( void,             glVertex4iv, (const GLint *v) );

OPENGL_FN_DECL( void,             glVertex4s, (GLshort x, GLshort y, GLshort z, GLshort w) );

OPENGL_FN_DECL( void,             glVertex4sv, (const GLshort *v) );

OPENGL_FN_DECL( void,             glVertexPointer, (GLint size, GLenum type, GLsizei stride, const GLvoid *pointer) );

OPENGL_FN_DECL( void,             glViewport, (GLint x, GLint y, GLsizei width, GLsizei height) );



//////////////// For GLU functions. //////////////////////



OPENGL_FN_DECL( const GLubyte*,   gluErrorString, (GLenum errCode) );

OPENGL_FN_DECL( const wchar_t*,   gluErrorUnicodeStringEXT, (GLenum errCode) );

OPENGL_FN_DECL( const GLubyte*,   gluGetString, (GLenum name) );

OPENGL_FN_DECL( void,             gluOrtho2D, (GLdouble left, GLdouble right, GLdouble bottom, GLdouble top) );

OPENGL_FN_DECL( void,             gluPerspective, (GLdouble fovy, GLdouble aspect, GLdouble zNear, GLdouble zFar) );

OPENGL_FN_DECL( void,             gluPickMatrix, (GLdouble x, GLdouble y, GLdouble width, GLdouble height, GLint viewport[4]) );

OPENGL_FN_DECL( void,             gluLookAt, (GLdouble eyex, GLdouble eyey, GLdouble eyez, GLdouble centerx, GLdouble centery, GLdouble centerz, GLdouble upx, GLdouble upy, GLdouble upz) );

OPENGL_FN_DECL( int,              gluProject, (GLdouble objx, GLdouble objy, GLdouble objz, const GLdouble modelMatrix[16], const GLdouble projMatrix[16], const GLint viewport[4], GLdouble *winx, GLdouble *winy, GLdouble *winz) );

OPENGL_FN_DECL( int,              gluUnProject, (GLdouble winx, GLdouble winy, GLdouble winz, const GLdouble modelMatrix[16], const GLdouble projMatrix[16], const GLint viewport[4], GLdouble *objx, GLdouble *objy, GLdouble *objz) );

OPENGL_FN_DECL( int,              gluScaleImage, (GLenum format, GLint widthin, GLint heightin, GLenum typein, const void *datain, GLint widthout, GLint heightout, GLenum typeout, void *dataout) );

OPENGL_FN_DECL( int,              gluBuild1DMipmaps, (GLenum target, GLint components, GLint width, GLenum format, GLenum type, const void *data) );

OPENGL_FN_DECL( int,              gluBuild2DMipmaps, (GLenum target, GLint components, GLint width, GLint height, GLenum format, GLenum type, const void *data) );

OPENGL_FN_DECL( GLUquadric*,      gluNewQuadric, (void) );

OPENGL_FN_DECL( void,             gluDeleteQuadric, (GLUquadric *state) );

OPENGL_FN_DECL( void,             gluQuadricNormals, (GLUquadric *quadObject, GLenum normals) );

OPENGL_FN_DECL( void,             gluQuadricTexture, (GLUquadric *quadObject, GLboolean textureCoords) );

OPENGL_FN_DECL( void,             gluQuadricOrientation, (GLUquadric *quadObject, GLenum orientation) );

OPENGL_FN_DECL( void,             gluQuadricDrawStyle, (GLUquadric *quadObject, GLenum drawStyle) );

OPENGL_FN_DECL( void,             gluCylinder, (GLUquadric *qobj, GLdouble baseRadius, GLdouble topRadius, GLdouble height, GLint slices, GLint stacks) );

OPENGL_FN_DECL( void,             gluDisk, (GLUquadric *qobj, GLdouble innerRadius, GLdouble outerRadius, GLint slices, GLint loops) );

OPENGL_FN_DECL( void,             gluPartialDisk, (GLUquadric *qobj, GLdouble innerRadius, GLdouble outerRadius, GLint slices, GLint loops, GLdouble startAngle, GLdouble sweepAngle) );

OPENGL_FN_DECL( void,             gluSphere, (GLUquadric *qobj, GLdouble radius, GLint slices, GLint stacks) );

OPENGL_FN_DECL( void,             gluQuadricCallback, (GLUquadric *qobj, GLenum which, void (CALLBACK* fn)()) );

OPENGL_FN_DECL( GLUtesselator*,   gluNewTess, (void ) );

OPENGL_FN_DECL( void,             gluDeleteTess, (GLUtesselator *tess ) );

OPENGL_FN_DECL( void,             gluTessBeginPolygon, (GLUtesselator *tess,void *polygon_data ) );

OPENGL_FN_DECL( void,             gluTessBeginContour, (GLUtesselator *tess ) );

OPENGL_FN_DECL( void,             gluTessVertex, (GLUtesselator *tess,GLdouble coords[3], void *data ) );

OPENGL_FN_DECL( void,             gluTessEndContour, (GLUtesselator *tess ) );

OPENGL_FN_DECL( void,             gluTessEndPolygon, (GLUtesselator *tess ) );

OPENGL_FN_DECL( void,             gluTessProperty, (GLUtesselator *tess,GLenum which, GLdouble value ) );

OPENGL_FN_DECL( void,             gluTessNormal, (GLUtesselator *tess, GLdouble x,GLdouble y, GLdouble z ) );

OPENGL_FN_DECL( void,             gluTessCallback, (GLUtesselator *tess,GLenum which, void (CALLBACK* fn)()) );

OPENGL_FN_DECL( void,             gluGetTessProperty, (GLUtesselator *tess,GLenum which, GLdouble *value ) );

OPENGL_FN_DECL( GLUnurbs*,        gluNewNurbsRenderer, (void) );

OPENGL_FN_DECL( void,             gluDeleteNurbsRenderer, (GLUnurbs *nobj) );

OPENGL_FN_DECL( void,             gluBeginSurface, (GLUnurbs *nobj) );

OPENGL_FN_DECL( void,             gluBeginCurve, (GLUnurbs *nobj) );

OPENGL_FN_DECL( void,             gluEndCurve, (GLUnurbs *nobj) );

OPENGL_FN_DECL( void,             gluEndSurface, (GLUnurbs *nobj) );

OPENGL_FN_DECL( void,             gluBeginTrim, (GLUnurbs *nobj) );

OPENGL_FN_DECL( void,             gluEndTrim, (GLUnurbs *nobj) );

OPENGL_FN_DECL( void,             gluPwlCurve, (GLUnurbs *nobj, GLint count, GLfloat *array, GLint stride, GLenum type) );

OPENGL_FN_DECL( void,             gluNurbsCurve, (GLUnurbs *nobj, GLint nknots, GLfloat *knot, GLint stride, GLfloat *ctlarray, GLint order, GLenum type) );

OPENGL_FN_DECL( void,             gluNurbsSurface, (GLUnurbs *nobj, GLint sknot_count, float *sknot, GLint tknot_count, GLfloat *tknot, GLint s_stride, GLint t_stride, GLfloat *ctlarray, GLint sorder, GLint torder, GLenum type) );

OPENGL_FN_DECL( void,             gluLoadSamplingMatrices, (GLUnurbs *nobj, const GLfloat modelMatrix[16], const GLfloat projMatrix[16], const GLint viewport[4] ) );

OPENGL_FN_DECL( void,             gluNurbsProperty, (GLUnurbs *nobj, GLenum property, GLfloat value ) );

OPENGL_FN_DECL( void,             gluGetNurbsProperty, (GLUnurbs *nobj, GLenum property, GLfloat *value ) );

OPENGL_FN_DECL( void,             gluNurbsCallback, ( GLUnurbs *nobj, GLenum which, void (CALLBACK* fn)()) );



//////////////// For GL_ARB_multitexture extension. //////////////////////



OPENGL_FN_DECL( void,             glActiveTextureARB, (GLenum target) );

OPENGL_FN_DECL( void,             glClientActiveTextureARB, (GLenum target) );

OPENGL_FN_DECL( void,             glMultiTexCoord1dARB, (GLenum target, GLdouble s) );

OPENGL_FN_DECL( void,             glMultiTexCoord1dvARB, (GLenum target, const GLdouble *v) );

OPENGL_FN_DECL( void,             glMultiTexCoord1fARB, (GLenum target, GLfloat s) );

OPENGL_FN_DECL( void,             glMultiTexCoord1fvARB, (GLenum target, const GLfloat *v) );

OPENGL_FN_DECL( void,             glMultiTexCoord1iARB, (GLenum target, GLint s) );

OPENGL_FN_DECL( void,             glMultiTexCoord1ivARB, (GLenum target, const GLint *v) );

OPENGL_FN_DECL( void,             glMultiTexCoord1sARB, (GLenum target, GLshort s) );

OPENGL_FN_DECL( void,             glMultiTexCoord1svARB, (GLenum target, const GLshort *v) );

OPENGL_FN_DECL( void,             glMultiTexCoord2dARB, (GLenum target, GLdouble s, GLdouble t) );

OPENGL_FN_DECL( void,             glMultiTexCoord2dvARB, (GLenum target, const GLdouble *v) );

OPENGL_FN_DECL( void,             glMultiTexCoord2fARB, (GLenum target, GLfloat s, GLfloat t) );

OPENGL_FN_DECL( void,             glMultiTexCoord2fvARB, (GLenum target, const GLfloat *v) );

OPENGL_FN_DECL( void,             glMultiTexCoord2iARB, (GLenum target, GLint s, GLint t) );

OPENGL_FN_DECL( void,             glMultiTexCoord2ivARB, (GLenum target, const GLint *v) );

OPENGL_FN_DECL( void,             glMultiTexCoord2sARB, (GLenum target, GLshort s, GLshort t) );

OPENGL_FN_DECL( void,             glMultiTexCoord2svARB, (GLenum target, const GLshort *v) );

OPENGL_FN_DECL( void,             glMultiTexCoord3dARB, (GLenum target, GLdouble s, GLdouble t, GLdouble r) );

OPENGL_FN_DECL( void,             glMultiTexCoord3dvARB, (GLenum target, const GLdouble *v) );

OPENGL_FN_DECL( void,             glMultiTexCoord3fARB, (GLenum target, GLfloat s, GLfloat t, GLfloat r) );

OPENGL_FN_DECL( void,             glMultiTexCoord3fvARB, (GLenum target, const GLfloat *v) );

OPENGL_FN_DECL( void,             glMultiTexCoord3iARB, (GLenum target, GLint s, GLint t, GLint r) );

OPENGL_FN_DECL( void,             glMultiTexCoord3ivARB, (GLenum target, const GLint *v) );

OPENGL_FN_DECL( void,             glMultiTexCoord3sARB, (GLenum target, GLshort s, GLshort t, GLshort r) );

OPENGL_FN_DECL( void,             glMultiTexCoord3svARB, (GLenum target, const GLshort *v) );

OPENGL_FN_DECL( void,             glMultiTexCoord4dARB, (GLenum target, GLdouble s, GLdouble t, GLdouble r, GLdouble q) );

OPENGL_FN_DECL( void,             glMultiTexCoord4dvARB, (GLenum target, const GLdouble *v) );

OPENGL_FN_DECL( void,             glMultiTexCoord4fARB, (GLenum target, GLfloat s, GLfloat t, GLfloat r, GLfloat q) );

OPENGL_FN_DECL( void,             glMultiTexCoord4fvARB, (GLenum target, const GLfloat *v) );

OPENGL_FN_DECL( void,             glMultiTexCoord4iARB, (GLenum target, GLint s, GLint t, GLint r, GLint q) );

OPENGL_FN_DECL( void,             glMultiTexCoord4ivARB, (GLenum target, const GLint *v) );

OPENGL_FN_DECL( void,             glMultiTexCoord4sARB, (GLenum target, GLshort s, GLshort t, GLshort r, GLshort q) );

OPENGL_FN_DECL( void,             glMultiTexCoord4svARB, (GLenum target, const GLshort *v) );



///////////////// For GL_EXT_compiled_vertex_array extension. ////////////



OPENGL_FN_DECL( void,             glLockArraysEXT, (GLint first, GLsizei count) );

OPENGL_FN_DECL( void,             glUnlockArraysEXT, (void) );



///////////////// For WGL_EXT_swap_control extension. ////////////



OPENGL_FN_DECL( GLboolean,        wglSwapIntervalEXT, (GLint interval) );

OPENGL_FN_DECL( int,              wglGetSwapIntervalEXT, (void) );



///////////////// For GL_EXT_point_parameters extension. ////////////



OPENGL_FN_DECL( void,             glPointParameterfEXT, (GLenum pname, GLfloat param) );

OPENGL_FN_DECL( void,             glPointParameterfvEXT, (GLenum pname, GLfloat *params) );



//////////////////////////////////////////////////////////////////////////



extern BOOL openglBypassGDI;



void      OpenGLFindDriver(char *openglLib);

int       OpenGLInit(char *lib);

void      OpenGLLoadExtensions(void);

void      OpenGLUnInit(void);

GLboolean OpenGLCheckExtension(char *extName);



/* Use these instead of the wgl* functions */

BOOL      OpenGLCopyContext(HGLRC hglrcSrc, HGLRC hlglrcDst, UINT mask);

HGLRC     OpenGLCreateContext(HDC hdc);

//HGLRC     OpenGLCreateLayerContext(HDC, int);

BOOL      OpenGLDeleteContext(HGLRC hglrc);

//HGLRC     OpenGLGetCurrentContext(VOID);

//HGLRC     OpenGLGetCurrentDC(VOID);

PROC      OpenGLGetProcAddress(LPCSTR lpcstr);

BOOL      OpenGLMakeCurrent(HDC hdc, HGLRC hglrc);

//BOOL      OpenGLShareLists(HGLRC, HGLRC);

BOOL      OpenGLUseFontBitmaps(HDC hdc, DWORD first, DWORD count, DWORD listBase);

BOOL      OpenGLSwapLayerBuffers(HDC hdc, UINT fuPlanes);



/* use these functions instead of the GDI ones */

BOOL      OpenGLSwapBuffers(HDC hdc);

int       OpenGLChoosePixelFormat(HDC hdc, CONST PIXELFORMATDESCRIPTOR * ppfd);

int       OpenGLDescribePixelFormat(HDC hdc, int iPixelFormat, UINT nBytes, LPPIXELFORMATDESCRIPTOR ppfd);

BOOL      OpenGLSetPixelFormat(HDC hdc, int iPixelFormat, CONST PIXELFORMATDESCRIPTOR * ppfd);



#ifndef __PLASMA_OPENGL_C

  /* And now for some ease of use macro's */

  #define wglCreateContext(hdc)                             OpenGLCreateContext(hdc)

  #define wglDeleteContext(hglrc)                           OpenGLDeleteContext(hglrc)

  #define wglMakeCurrent(hdc, hglrc)                        OpenGLMakeCurrent(hdc, hglrc)

  #define wglSwapLayerBuffers(hdc, hglrc)                   OpenGLSwapLayerBuffers(hdc, hglrc)

  #define wglUseFontBitmapsW(hdc, first, count, listBase)   OpenGLUseFontBitmapsW(hdc, first, count, listBase)

  #define wglUseFontBitmapsA(hdc, first, count, listBase)   OpenGLUseFontBitmapsA(hdc, first, count, listBase)

  #define wglGetProcAddress(lpcstr)                         OpenGLGetProcAddress(lpcstr)



  /* Take care of the whole wglUseFontBitmaps mess */

#if defined(wglUseFontBitmaps)

  #undef wglUseFontBitmaps

#endif

#ifdef UNICODE

  #define wglUseFontBitmaps(hdc, first, count, listBase)    OpenGLUseFontBitmapsW(hdc, first, count, listBase)

#else

  #define wglUseFontBitmaps(hdc, first, count, listBase)    OpenGLUseFontBitmapsA(hdc, first, count, listBase)

#endif // !UNICODE



  #define SwapBuffers(hdc)                                  OpenGLSwapBuffers(hdc)

  #define ChoosePixelFormat(hdc, ppfd)                      OpenGLChoosePixelFormat(hdc, ppfd)

  #define DescribePixelFormat(hdc, iPF, nBytes, ppfd)       OpenGLDescribePixelFormat(hdc, iPF, nBytes, ppfd)

  #define SetPixelFormat(hdc, iPF, ppfd)                    OpenGLSetPixelFormat(hdc, iPF, ppfd)



  /* Map all the gl, glu, glArb etc. functions right to the fn pointer for speed */

  #define glAccum                   fnglAccum

  #define glAlphaFunc               fnglAlphaFunc

  #define glAreTexturesResident     fnglAreTexturesResident

  #define glArrayElement            fnglArrayElement

  #define glBegin                   fnglBegin

  #define glBindTexture             fnglBindTexture

  #define glBitmap                  fnglBitmap

  #define glBlendFunc               fnglBlendFunc

  #define glCallList                fnglCallList

  #define glCallLists               fnglCallLists

  #define glClear                   fnglClear

  #define glClearAccum              fnglClearAccum

  #define glClearColor              fnglClearColor

  #define glClearDepth              fnglClearDepth

  #define glClearIndex              fnglClearIndex

  #define glClearStencil            fnglClearStencil

  #define glClipPlane               fnglClipPlane

  #define glColor3b                 fnglColor3b

  #define glColor3bv                fnglColor3bv

  #define glColor3d                 fnglColor3d

  #define glColor3dv                fnglColor3dv

  #define glColor3f                 fnglColor3f

  #define glColor3fv                fnglColor3fv

  #define glColor3i                 fnglColor3i

  #define glColor3iv                fnglColor3iv

  #define glColor3s                 fnglColor3s

  #define glColor3sv                fnglColor3sv

  #define glColor3ub                fnglColor3ub

  #define glColor3ubv               fnglColor3ubv

  #define glColor3ui                fnglColor3ui

  #define glColor3uiv               fnglColor3uiv

  #define glColor3us                fnglColor3us

  #define glColor3usv               fnglColor3usv

  #define glColor4b                 fnglColor4b

  #define glColor4bv                fnglColor4bv

  #define glColor4d                 fnglColor4d

  #define glColor4dv                fnglColor4dv

  #define glColor4f                 fnglColor4f

  #define glColor4fv                fnglColor4fv

  #define glColor4i                 fnglColor4i

  #define glColor4iv                fnglColor4iv

  #define glColor4s                 fnglColor4s

  #define glColor4sv                fnglColor4sv

  #define glColor4ub                fnglColor4ub

  #define glColor4ubv               fnglColor4ubv

  #define glColor4ui                fnglColor4ui

  #define glColor4uiv               fnglColor4uiv

  #define glColor4us                fnglColor4us

  #define glColor4usv               fnglColor4usv

  #define glColorMask               fnglColorMask

  #define glColorMaterial           fnglColorMaterial

  #define glColorPointer            fnglColorPointer

  #define glCopyPixels              fnglCopyPixels

  #define glCopyTexImage1D          fnglCopyTexImage1D

  #define glCopyTexImage2D          fnglCopyTexImage2D

  #define glCopyTexSubImage1D       fnglCopyTexSubImage1D

  #define glCopyTexSubImage2D       fnglCopyTexSubImage2D

  #define glCullFace                fnglCullFace

  #define glDeleteLists             fnglDeleteLists

  #define glDeleteTextures          fnglDeleteTextures

  #define glDepthFunc               fnglDepthFunc

  #define glDepthMask               fnglDepthMask

  #define glDepthRange              fnglDepthRange

  #define glDisable                 fnglDisable

  #define glDisableClientState      fnglDisableClientState

  #define glDrawArrays              fnglDrawArrays

  #define glDrawBuffer              fnglDrawBuffer

  #define glDrawElements            fnglDrawElements

  #define glDrawPixels              fnglDrawPixels

  #define glEdgeFlag                fnglEdgeFlag

  #define glEdgeFlagPointer         fnglEdgeFlagPointer

  #define glEdgeFlagv               fnglEdgeFlagv

  #define glEnable                  fnglEnable

  #define glEnableClientState       fnglEnableClientState

  #define glEnd                     fnglEnd

  #define glEndList                 fnglEndList

  #define glEvalCoord1d             fnglEvalCoord1d

  #define glEvalCoord1dv            fnglEvalCoord1dv

  #define glEvalCoord1f             fnglEvalCoord1f

  #define glEvalCoord1fv            fnglEvalCoord1fv

  #define glEvalCoord2d             fnglEvalCoord2d

  #define glEvalCoord2dv            fnglEvalCoord2dv

  #define glEvalCoord2f             fnglEvalCoord2f

  #define glEvalCoord2fv            fnglEvalCoord2fv

  #define glEvalMesh1               fnglEvalMesh1

  #define glEvalMesh2               fnglEvalMesh2

  #define glEvalPoint1              fnglEvalPoint1

  #define glEvalPoint2              fnglEvalPoint2

  #define glFeedbackBuffer          fnglFeedbackBuffer

  #define glFinish                  fnglFinish

  #define glFlush                   fnglFlush

  #define glFogf                    fnglFogf

  #define glFogfv                   fnglFogfv

  #define glFogi                    fnglFogi

  #define glFogiv                   fnglFogiv

  #define glFrontFace               fnglFrontFace

  #define glFrustum                 fnglFrustum

  #define glGenLists                fnglGenLists

  #define glGenTextures             fnglGenTextures

  #define glGetBooleanv             fnglGetBooleanv

  #define glGetClipPlane            fnglGetClipPlane

  #define glGetDoublev              fnglGetDoublev

  #define glGetError                fnglGetError

  #define glGetFloatv               fnglGetFloatv

  #define glGetIntegerv             fnglGetIntegerv

  #define glGetLightfv              fnglGetLightfv

  #define glGetLightiv              fnglGetLightiv

  #define glGetMapdv                fnglGetMapdv

  #define glGetMapfv                fnglGetMapfv

  #define glGetMapiv                fnglGetMapiv

  #define glGetMaterialfv           fnglGetMaterialfv

  #define glGetMaterialiv           fnglGetMaterialiv

  #define glGetPixelMapfv           fnglGetPixelMapfv

  #define glGetPixelMapuiv          fnglGetPixelMapuiv

  #define glGetPixelMapusv          fnglGetPixelMapusv

  #define glGetPointerv             fnglGetPointerv

  #define glGetPolygonStipple       fnglGetPolygonStipple

  #define glGetString               fnglGetString

  #define glGetTexEnvfv             fnglGetTexEnvfv

  #define glGetTexEnviv             fnglGetTexEnviv

  #define glGetTexGendv             fnglGetTexGendv

  #define glGetTexGenfv             fnglGetTexGenfv

  #define glGetTexGeniv             fnglGetTexGeniv

  #define glGetTexImage             fnglGetTexImage

  #define glGetTexLevelParameterfv  fnglGetTexLevelParameterfv

  #define glGetTexLevelParameteriv  fnglGetTexLevelParameteriv

  #define glGetTexParameterfv       fnglGetTexParameterfv

  #define glGetTexParameteriv       fnglGetTexParameteriv

  #define glHint                    fnglHint

  #define glIndexMask               fnglIndexMask

  #define glIndexPointer            fnglIndexPointer

  #define glIndexd                  fnglIndexd

  #define glIndexdv                 fnglIndexdv

  #define glIndexf                  fnglIndexf

  #define glIndexfv                 fnglIndexfv

  #define glIndexi                  fnglIndexi

  #define glIndexiv                 fnglIndexiv

  #define glIndexs                  fnglIndexs

  #define glIndexsv                 fnglIndexsv

  #define glIndexub                 fnglIndexub

  #define glIndexubv                fnglIndexubv

  #define glInitNames               fnglInitNames

  #define glInterleavedArrays       fnglInterleavedArrays

  #define glIsEnabled               fnglIsEnabled

  #define glIsList                  fnglIsList

  #define glIsTexture               fnglIsTexture

  #define glLightModelf             fnglLightModelf

  #define glLightModelfv            fnglLightModelfv

  #define glLightModeli             fnglLightModeli

  #define glLightModeliv            fnglLightModeliv

  #define glLightf                  fnglLightf

  #define glLightfv                 fnglLightfv

  #define glLighti                  fnglLighti

  #define glLightiv                 fnglLightiv

  #define glLineStipple             fnglLineStipple

  #define glLineWidth               fnglLineWidth

  #define glListBase                fnglListBase

  #define glLoadIdentity            fnglLoadIdentity

  #define glLoadMatrixd             fnglLoadMatrixd

  #define glLoadMatrixf             fnglLoadMatrixf

  #define glLoadName                fnglLoadName

  #define glLogicOp                 fnglLogicOp

  #define glMap1d                   fnglMap1d

  #define glMap1f                   fnglMap1f

  #define glMap2d                   fnglMap2d

  #define glMap2f                   fnglMap2f

  #define glMapGrid1d               fnglMapGrid1d

  #define glMapGrid1f               fnglMapGrid1f

  #define glMapGrid2d               fnglMapGrid2d

  #define glMapGrid2f               fnglMapGrid2f

  #define glMaterialf               fnglMaterialf

  #define glMaterialfv              fnglMaterialfv

  #define glMateriali               fnglMateriali

  #define glMaterialiv              fnglMaterialiv

  #define glMatrixMode              fnglMatrixMode

  #define glMultMatrixd             fnglMultMatrixd

  #define glMultMatrixf             fnglMultMatrixf

  #define glNewList                 fnglNewList

  #define glNormal3b                fnglNormal3b

  #define glNormal3bv               fnglNormal3bv

  #define glNormal3d                fnglNormal3d

  #define glNormal3dv               fnglNormal3dv

  #define glNormal3f                fnglNormal3f

  #define glNormal3fv               fnglNormal3fv

  #define glNormal3i                fnglNormal3i

  #define glNormal3iv               fnglNormal3iv

  #define glNormal3s                fnglNormal3s

  #define glNormal3sv               fnglNormal3sv

  #define glNormalPointer           fnglNormalPointer

  #define glOrtho                   fnglOrtho

  #define glPassThrough             fnglPassThrough

  #define glPixelMapfv              fnglPixelMapfv

  #define glPixelMapuiv             fnglPixelMapuiv

  #define glPixelMapusv             fnglPixelMapusv

  #define glPixelStoref             fnglPixelStoref

  #define glPixelStorei             fnglPixelStorei

  #define glPixelTransferf          fnglPixelTransferf

  #define glPixelTransferi          fnglPixelTransferi

  #define glPixelZoom               fnglPixelZoom

  #define glPointSize               fnglPointSize

  #define glPolygonMode             fnglPolygonMode

  #define glPolygonOffset           fnglPolygonOffset

  #define glPolygonStipple          fnglPolygonStipple

  #define glPopAttrib               fnglPopAttrib

  #define glPopClientAttrib         fnglPopClientAttrib

  #define glPopMatrix               fnglPopMatrix

  #define glPopName                 fnglPopName

  #define glPrioritizeTextures      fnglPrioritizeTextures

  #define glPushAttrib              fnglPushAttrib

  #define glPushClientAttrib        fnglPushClientAttrib

  #define glPushMatrix              fnglPushMatrix

  #define glPushName                fnglPushName

  #define glRasterPos2d             fnglRasterPos2d

  #define glRasterPos2dv            fnglRasterPos2dv

  #define glRasterPos2f             fnglRasterPos2f

  #define glRasterPos2fv            fnglRasterPos2fv

  #define glRasterPos2i             fnglRasterPos2i

  #define glRasterPos2iv            fnglRasterPos2iv

  #define glRasterPos2s             fnglRasterPos2s

  #define glRasterPos2sv            fnglRasterPos2sv

  #define glRasterPos3d             fnglRasterPos3d

  #define glRasterPos3dv            fnglRasterPos3dv

  #define glRasterPos3f             fnglRasterPos3f

  #define glRasterPos3fv            fnglRasterPos3fv

  #define glRasterPos3i             fnglRasterPos3i

  #define glRasterPos3iv            fnglRasterPos3iv

  #define glRasterPos3s             fnglRasterPos3s

  #define glRasterPos3sv            fnglRasterPos3sv

  #define glRasterPos4d             fnglRasterPos4d

  #define glRasterPos4dv            fnglRasterPos4dv

  #define glRasterPos4f             fnglRasterPos4f

  #define glRasterPos4fv            fnglRasterPos4fv

  #define glRasterPos4i             fnglRasterPos4i

  #define glRasterPos4iv            fnglRasterPos4iv

  #define glRasterPos4s             fnglRasterPos4s

  #define glRasterPos4sv            fnglRasterPos4sv

  #define glReadBuffer              fglReadBuffer

  #define glReadPixels              fnglReadPixels

  #define glRectd                   fnglRectd

  #define glRectdv                  fnglRectdv

  #define glRectf                   fnglRectf

  #define glRectfv                  fnglRectfv

  #define glRecti                   fnglRecti

  #define glRectiv                  fnglRectiv

  #define glRects                   fnglRects

  #define glRectsv                  fnglRectsv

  #define glRenderMode              fnglRenderMode

  #define glRotated                 fnglRotated

  #define glRotatef                 fnglRotatef

  #define glScaled                  fnglScaled

  #define glScalef                  fnglScalef

  #define glScissor                 fnglScissor

  #define glSelectBuffer            fnglSelectBuffer

  #define glShadeModel              fnglShadeModel

  #define glStencilFunc             fnglStencilFunc

  #define glStencilMask             fnglStencilMask

  #define glStencilOp               fnglStencilOp

  #define glTexCoord1d              fnglTexCoord1d

  #define glTexCoord1dv             fnglTexCoord1dv

  #define glTexCoord1f              fnglTexCoord1f

  #define glTexCoord1fv             fnglTexCoord1fv

  #define glTexCoord1i              fnglTexCoord1i

  #define glTexCoord1iv             fnglTexCoord1iv

  #define glTexCoord1s              fnglTexCoord1s

  #define glTexCoord1sv             fnglTexCoord1sv

  #define glTexCoord2d              fnglTexCoord2d

  #define glTexCoord2dv             fnglTexCoord2dv

  #define glTexCoord2f              fnglTexCoord2f

  #define glTexCoord2fv             fnglTexCoord2fv

  #define glTexCoord2i              fnglTexCoord2i

  #define glTexCoord2iv             fnglTexCoord2iv

  #define glTexCoord2s              fnglTexCoord2s

  #define glTexCoord2sv             fnglTexCoord2sv

  #define glTexCoord3d              fnglTexCoord3d

  #define glTexCoord3dv             fnglTexCoord3dv

  #define glTexCoord3f              fnglTexCoord3f

  #define glTexCoord3fv             fnglTexCoord3fv

  #define glTexCoord3i              fnglTexCoord3i

  #define glTexCoord3iv             fnglTexCoord3iv

  #define glTexCoord3s              fnglTexCoord3s

  #define glTexCoord3sv             fnglTexCoord3sv

  #define glTexCoord4d              fnglTexCoord4d

  #define glTexCoord4dv             fnglTexCoord4dv

  #define glTexCoord4f              fnglTexCoord4f

  #define glTexCoord4fv             fnglTexCoord4fv

  #define glTexCoord4i              fnglTexCoord4i

  #define glTexCoord4iv             fnglTexCoord4iv

  #define glTexCoord4s              fnglTexCoord4s

  #define glTexCoord4sv             fnglTexCoord4sv

  #define glTexCoordPointer         fnglTexCoordPointer

  #define glTexEnvf                 fnglTexEnvf

  #define glTexEnvfv                fnglTexEnvfv

  #define glTexEnvi                 fnglTexEnvi

  #define glTexEnviv                fnglTexEnviv

  #define glTexGend                 fnglTexGend

  #define glTexGendv                fnglTexGendv

  #define glTexGenf                 fnglTexGenf

  #define glTexGenfv                fnglTexGenfv

  #define glTexGeni                 fnglTexGeni

  #define glTexGeniv                fnglTexGeniv

  #define glTexImage1D              fnglTexImage1D

  #define glTexImage2D              fnglTexImage2D

  #define glTexParameterf           fnglTexParameterf

  #define glTexParameterfv          fnglTexParameterfv

  #define glTexParameteri           fnglTexParameteri

  #define glTexParameteriv          fnglTexParameteriv

  #define glTexSubImage1D           fnglTexSubImage1D

  #define glTexSubImage2D           fnglTexSubImage2D

  #define glTranslated              fnglTranslated

  #define glTranslatef              fnglTranslatef

  #define glVertex2d                fnglVertex2d

  #define glVertex2dv               fnglVertex2dv

  #define glVertex2f                fnglVertex2f

  #define glVertex2fv               fnglVertex2fv

  #define glVertex2i                fnglVertex2i

  #define glVertex2iv               fnglVertex2iv

  #define glVertex2s                fnglVertex2s

  #define glVertex2sv               fnglVertex2sv

  #define glVertex3d                fnglVertex3d

  #define glVertex3dv               fnglVertex3dv

  #define glVertex3f                fnglVertex3f

  #define glVertex3fv               fnglVertex3fv

  #define glVertex3i                fnglVertex3i

  #define glVertex3iv               fnglVertex3iv

  #define glVertex3s                fnglVertex3s

  #define glVertex3sv               fnglVertex3sv

  #define glVertex4d                fnglVertex4d

  #define glVertex4dv               fnglVertex4dv

  #define glVertex4f                fnglVertex4f

  #define glVertex4fv               fnglVertex4fv

  #define glVertex4i                fnglVertex4i

  #define glVertex4iv               fnglVertex4iv

  #define glVertex4s                fnglVertex4s

  #define glVertex4sv               fnglVertex4sv

  #define glVertexPointer           fnglVertexPointer

  #define glViewport                fnglViewport



  #define gluErrorString            fngluErrorString

  #define gluErrorUnicodeStringEXT  fngluErrorUnicodeStringEXT

  #define gluGetString              fngluGetString

  #define gluOrtho2D                fngluOrtho2D

  #define gluPerspective            fngluPerspective

  #define gluPickMatrix             fngluPickMatrix

  #define gluLookAt                 fngluLookAt

  #define gluProject                fngluProject

  #define gluUnProject              fngluUnProject

  #define gluScaleImage             fngluScaleImage

  #define gluBuild1DMipmaps         fngluBuild1DMipmaps

  #define gluBuild2DMipmaps         fngluBuild2DMipmaps

  #define gluNewQuadric             fngluNewQuadric

  #define gluDeleteQuadric          fngluDeleteQuadric

  #define gluQuadricNormals         fngluQuadricNormals

  #define gluQuadricTexture         fngluQuadricTexture

  #define gluQuadricOrientation     fngluQuadricOrientation

  #define gluQuadricDrawStyle       fngluQuadricDrawStyle

  #define gluCylinder               fngluCylinder

  #define gluDisk                   fngluDisk

  #define gluPartialDisk            fngluPartialDisk

  #define gluSphere                 fngluSphere

  #define gluQuadricCallback        fngluQuadricCallback

  #define gluNewTess                fngluNewTess

  #define gluDeleteTess             fngluDeleteTess

  #define gluTessBeginPolygon       fngluTessBeginPolygon

  #define gluTessBeginContour       fngluTessBeginContour

  #define gluTessVertex             fngluTessVertex

  #define gluTessEndContour         fngluTessEndContour

  #define gluTessEndPolygon         fngluTessEndPolygon

  #define gluTessProperty           fngluTessProperty

  #define gluTessNormal             fngluTessNormal

  #define gluTessCallback           fngluTessCallback

  #define gluGetTessProperty        fngluGetTessProperty

  #define gluNewNurbsRenderer       fngluNewNurbsRenderer

  #define gluDeleteNurbsRenderer    fngluDeleteNurbsRenderer

  #define gluBeginSurface           fngluBeginSurface

  #define gluBeginCurve             fngluBeginCurve

  #define gluEndCurve               fngluEndCurve

  #define gluEndSurface             fngluEndSurface

  #define gluBeginTrim              fngluBeginTrim

  #define gluEndTrim                fngluEndTrim

  #define gluPwlCurve               fngluPwlCurve

  #define gluNurbsCurve             fngluNurbsCurve

  #define gluNurbsSurface           fngluNurbsSurface

  #define gluLoadSamplingMatrices   fngluLoadSamplingMatrices

  #define gluNurbsProperty          fngluNurbsProperty

  #define gluGetNurbsProperty       fngluGetNurbsProperty

  #define gluNurbsCallback          fngluNurbsCallback



  //////////////// For GL_ARB_multitexture extension. //////////////////////

  #define glActiveTextureARB        fnglActiveTextureARB

  #define glClientActiveTextureARB  fnglClientActiveTextureARB

  #define glMultiTexCoord1dARB      fnglMultiTexCoord1dARB

  #define glMultiTexCoord1dvARB     fnglMultiTexCoord1dvARB

  #define glMultiTexCoord1fARB      fnglMultiTexCoord1fARB

  #define glMultiTexCoord1fvARB     fnglMultiTexCoord1fvARB

  #define glMultiTexCoord1iARB      fnglMultiTexCoord1iARB

  #define glMultiTexCoord1ivARB     fnglMultiTexCoord1ivARB

  #define glMultiTexCoord1sARB      fnglMultiTexCoord1sARB

  #define glMultiTexCoord1svARB     fnglMultiTexCoord1svARB

  #define glMultiTexCoord2dARB      fnglMultiTexCoord2dARB

  #define glMultiTexCoord2dvARB     fnglMultiTexCoord2dvARB

  #define glMultiTexCoord2fARB      fnglMultiTexCoord2fARB

  #define glMultiTexCoord2fvARB     fnglMultiTexCoord2fvARB

  #define glMultiTexCoord2iARB      fnglMultiTexCoord2iARB

  #define glMultiTexCoord2ivARB     fnglMultiTexCoord2ivARB

  #define glMultiTexCoord2sARB      fnglMultiTexCoord2sARB

  #define glMultiTexCoord2svARB     fnglMultiTexCoord2svARB

  #define glMultiTexCoord3dARB      fnglMultiTexCoord3dARB

  #define glMultiTexCoord3dvARB     fnglMultiTexCoord3dvARB

  #define glMultiTexCoord3fARB      fnglMultiTexCoord3fARB

  #define glMultiTexCoord3fvARB     fnglMultiTexCoord3fvARB

  #define glMultiTexCoord3iARB      fnglMultiTexCoord3iARB

  #define glMultiTexCoord3ivARB     fnglMultiTexCoord3ivARB

  #define glMultiTexCoord3sARB      fnglMultiTexCoord3sARB

  #define glMultiTexCoord3svARB     fnglMultiTexCoord3svARB

  #define glMultiTexCoord4dARB      fnglMultiTexCoord4dARB

  #define glMultiTexCoord4dvARB     fnglMultiTexCoord4dvARB

  #define glMultiTexCoord4fARB      fnglMultiTexCoord4fARB

  #define glMultiTexCoord4fvARB     fnglMultiTexCoord4fvARB

  #define glMultiTexCoord4iARB      fnglMultiTexCoord4iARB

  #define glMultiTexCoord4ivARB     fnglMultiTexCoord4ivARB

  #define glMultiTexCoord4sARB      fnglMultiTexCoord4sARB

  #define glMultiTexCoord4svARB     fnglMultiTexCoord4svARB



  ///////////////// For GL_EXT_compiled_vertex_array extension. ////////////

  #define glLockArraysEXT           fnglLockArraysEXT

  #define glUnlockArraysEXT         fnglUnlockArraysEXT



  ///////////////// For WGL_EXT_swap_control extension. ////////////

  #define wglSwapIntervalEXT        fnwglSwapIntervalEXT

  #define wglGetSwapIntervalEXT     fnwglGetSwapIntervalEXT



  ///////////////// For GL_EXT_point_parameters extension. ////////////

  #define glPointParameterfEXT      fnglPointParameterfEXT

  #define glPointParameterfvEXT     fnglPointParameterfvEXT



#endif



//////////////////////////////////////////////////////////////////////////



/* restore normal meaning of WINGDIAPI */

#undef WINGDIAPI

#define WINGDIAPI DECLSPEC_IMPORT



//////////////////////////////////////////////////////////////////////////



#ifdef __cplusplus

}

#endif



#endif



